package ShamirSecretSharing;

import java.math.BigInteger;

/**
 * Created by Tzlil on 1/28/2016.
 */
class LagrangePolynomial{
    public final Polynomial polynomial;
    public final BigInteger image;
    public final BigInteger divisor;

    private LagrangePolynomial(Polynomial polynomial, BigInteger image, BigInteger divisor) {
        this.polynomial = polynomial;
        this.image = image;
        this.divisor = divisor;
    }

    public static LagrangePolynomial[] lagrangePolynomials(Polynomial.Point[] points){
        LagrangePolynomial[] lagrangePolynomials = new LagrangePolynomial[points.length];
        Polynomial[] factors = new Polynomial[points.length];
        for (int i = 0 ; i < factors.length ; i++){
            factors[i] = new Polynomial(new BigInteger[]{BigInteger.ZERO.subtract(points[i].x),BigInteger.ONE}); // X - Xi
        }
        Polynomial product;
        BigInteger divisor;
        for(int i = 0; i < points.length; i ++) {
            product = Polynomial.ONE;
            divisor = BigInteger.ONE;
            for (int j = 0; j < points.length; j++) {
                if (i != j) {
                    divisor = divisor.multiply(points[i].x.subtract(points[j].x));
                    product = product.mul(factors[j]);
                }
            }
            lagrangePolynomials[i] = new LagrangePolynomial(product,points[i].y,divisor);
        }
        return lagrangePolynomials;
    }
}
